/*
    THIS FILE IS FOR USE WITH THE TUTORIAL IN "GETTING STARTED",
    IT IS NOT MEANT TO BE USED WITHOUT REFERRING TO THE MANUAL.

*   You must change the parameters below to match your
*   server name, database name , username, and password.
*
*   This file inserts data into the PROJECT,
*   EMPLOYEE_PROJECT, PROJ_DEPT_BUDGET, CUSTOMER, 
*   and SALES tables.
*/

CONNECT "server:\dir\mydb.gdb"
USER "USERNAME" PASSWORD "password";

/*
 *  Add projects.
 *  Some projects have no team leader.
 */

INSERT INTO project (proj_id, proj_name, team_leader, product) VALUES
('VBASE', 'Video Database', 45, 'software');

        /* proj_desc blob:
                  Design a video data base management system for
                  controlling on-demand video distribution.
        */

INSERT INTO project (proj_id, proj_name, team_leader, product) VALUES
('DGPII', 'DigiPizza', 24, 'other');

        /* proj_desc blob:
                  Develop second generation digital pizza maker
                  with flash-bake heating element and
                  digital ingredient measuring system.
        */

INSERT INTO project (proj_id, proj_name, team_leader, product) VALUES
('GUIDE', 'AutoMap', 20, 'hardware');

        /* proj_desc blob:
                  Develop a prototype for the automobile version of
                  the hand-held map browsing device.
        */

INSERT INTO project (proj_id, proj_name, team_leader, product) VALUES
('MAPDB', 'MapBrowser port', 4, 'software');

        /* proj_desc blob:
                  Port the map browsing database software to run
                  on the automobile model.
        */

INSERT INTO project (proj_id, proj_name, team_leader, product) VALUES
('HWRII', 'Translator upgrade', null, 'software');

        /* proj_desc blob:
                  Integrate the hand-writing recognition module into the
                  universal language translator.
        */

INSERT INTO project (proj_id, proj_name, team_leader, product) VALUES
('MKTPR', 'Marketing project 3', 85, 'N/A');

/* proj_desc blob:
                  Expand marketing and sales in the Pacific Rim.
                  Set up a field office in Australia and Singapore.
*/


/*
 *  Assign employees to projects.
 *  One project has no employees assigned.
 */

INSERT INTO employee_project (proj_id, emp_no) VALUES ('DGPII', 144);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('DGPII', 113);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('DGPII', 24);

INSERT INTO employee_project (proj_id, emp_no) VALUES ('VBASE', 8);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('VBASE', 136);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('VBASE', 15);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('VBASE', 71);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('VBASE', 145);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('VBASE', 44);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('VBASE', 4);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('VBASE', 83);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('VBASE', 138);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('VBASE', 45);

INSERT INTO employee_project (proj_id, emp_no) VALUES ('GUIDE', 20);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('GUIDE', 24);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('GUIDE', 113);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('GUIDE', 8);

INSERT INTO employee_project (proj_id, emp_no) VALUES ('MAPDB', 4);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('MAPDB', 71);

INSERT INTO employee_project (proj_id, emp_no) VALUES ('MKTPR', 46);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('MKTPR', 105);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('MKTPR', 12);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('MKTPR', 85);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('MKTPR', 110);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('MKTPR', 34);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('MKTPR', 8);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('MKTPR', 14);
INSERT INTO employee_project (proj_id, emp_no) VALUES ('MKTPR', 52);


/*
 *  Add project budget planning by department.
 *  Head count array is not added here.
 */

INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'GUIDE', '100', 200000);
        /* head count:  1,1,1,0 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'GUIDE', '671', 450000);
        /* head count:  3,2,1,0 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1993, 'MAPDB', '621', 20000);
        /* head count:  0,0,0,1 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'MAPDB', '621', 40000);
        /* head count:  2,1,0,0 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'MAPDB', '622', 60000);
        /* head count:  1,1,0,0 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'MAPDB', '671', 11000);
        /* head count:  1,1,0,0 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'HWRII', '670', 20000);
        /* head count:  1,1,1,1 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'HWRII', '621', 400000);
        /* head count:  2,3,2,1 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'HWRII', '622', 100000);
        /* head count:  1,1,2,2 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'MKTPR', '623', 80000);
        /* head count:  1,1,1,2 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'MKTPR', '672', 100000);
        /* head count:  1,1,1,2 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'MKTPR', '100', 1000000);
        /* head count:  4,5,6,6 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'MKTPR', '110', 200000);
        /* head count:  2,2,0,3 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'MKTPR', '000', 100000);
        /* head count:  1,1,2,2 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1995, 'MKTPR', '623', 1200000);
        /* head count:  7,7,4,4 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1995, 'MKTPR', '672', 800000);
        /* head count:  2,3,3,3 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1995, 'MKTPR', '100', 2000000);
        /* head count:  4,5,6,6 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1995, 'MKTPR', '110', 1200000);
        /* head count:  1,1,1,1 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'VBASE', '621', 1900000);
        /* head count:  4,5,5,3 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1995, 'VBASE', '621', 900000);
        /* head count:  4,3,2,2 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'VBASE', '622', 400000);
        /* head count:  2,2,2,1 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1994, 'VBASE', '100', 300000);
        /* head count:  1,1,2,3 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1995, 'VBASE', '100', 1500000);
        /* head count:  3,3,1,1 */
INSERT INTO proj_dept_budget (year, proj_id, dept_no, projected_budget) VALUES
(1996, 'VBASE', '100', 150000);
        /* head count:  1,1,0,0 */


/*
 *  Add a few customer records.
 */

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1001, 'Signature Design', 'Dale J.', 'Little', '(619) 530-2710',
'15500 Pacific Heights Blvd.', null, 'San Diego', 'CA', 'USA', '92121', null);

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1002, 'Dallas Technologies', 'Glen', 'Brown', '(214) 960-2233',
'P. O. Box 47000', null, 'Dallas', 'TX', 'USA', '75205', null);

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1003, 'Buttle, Griffith and Co.', 'James', 'Buttle', '(617) 488-1864',
'2300 Newbury Street', 'Suite 101', 'Boston', 'MA', 'USA', '02115', null);

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1004, 'Central Bank', 'Elizabeth', 'Brocket', '61 211 99 88',
'66 Lloyd Street', null, 'Manchester', null, 'England', 'M2 3LA', null);

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1005, 'DT Systems, LTD.', 'Tai', 'Wu', '(852) 850 43 98',
'400 Connaught Road', null, 'Central Hong Kong', null, 'Hong Kong', null, null);

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1006, 'DataServe International', 'Tomas', 'Bright', '(613) 229 3323',
'2000 Carling Avenue', 'Suite 150', 'Ottawa', 'ON', 'Canada', 'K1V 9G1', null);

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1007, 'Mrs. Beauvais', null, 'Mrs. Beauvais', null,
'P.O. Box 22743', null, 'Pebble Beach', 'CA', 'USA', '93953', null);

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1008, 'Anini Vacation Rentals', 'Leilani', 'Briggs', '(808) 835-7605',
'3320 Lawai Road', null, 'Lihue', 'HI', 'USA', '96766', null);

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1009, 'Max', 'Max', null, '22 01 23',
'1 Emerald Cove', null, 'Turtle Island', null, 'Fiji', null, null);

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1010, 'MPM Corporation', 'Miwako', 'Miyamoto', '3 880 77 19',
'2-64-7 Sasazuka', null, 'Tokyo', null, 'Japan', '150', null);

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1011, 'Dynamic Intelligence Corp', 'Victor', 'Granges', '01 221 16 50',
'Florhofgasse 10', null, 'Zurich', null, 'Switzerland', '8005', null);

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1012, '3D-Pad Corp.', 'Michelle', 'Roche', '1 43 60 61',
'22 Place de la Concorde', null, 'Paris', null, 'France', '75008', null);

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1013, 'Lorenzi Export, Ltd.', 'Andreas', 'Lorenzi', '02 404 6284',
'Via Eugenia, 15', null, 'Milan', null, 'Italy', '20124', null);

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1014, 'Dyno Consulting', 'Greta', 'Hessels', '02 500 5940',
'Rue Royale 350', null, 'Brussels', null, 'Belgium', '1210', null);

INSERT INTO customer
(cust_no, customer, contact_first, contact_last, phone_no, address_line1,
address_line2, city, state_province, country, postal_code, on_hold) VALUES
(1015, 'GeoTech Inc.', 'K.M.', 'Neppelenbroek', '(070) 44 91 18',
'P.0.Box 702', null, 'Den Haag', null, 'Netherlands', '2514', null);


/*
 *  Add some sales records.
*/

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V91E0210', 1004, 11,  '03/04/91', '03/05/91', null,
'shipped',      'y',    10,     5000,   0.1,    'hardware');

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V93J3100', 1010, 118, '08/20/93', '08/20/93', null,
'shipped',      'y',    16,     18000.40,       0.10, 'software');

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V93F3088', 1012, 134, '08/27/93', '09/08/93', null,
'shipped',      'n',    10,     10000,          0, 'software');

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V93F2030', 1012, 134, '12/12/93', null,    null,
'open',         'y',    15,     450000.49,      0, 'hardware');

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V93F2051', 1012, 134, '12/18/93', null, '03/01/94',
'waiting',      'n',    1,      999.98,         0, 'software');

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V93H0030', 1005, 118, '12/12/93', null, '01/01/94',
'open',         'y',    20,     5980,           0.20, 'software');

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V94H0079', 1005, 61, '02/13/94', null, '04/20/94',
'open',         'n',    10,     9000,           0.05, 'software');

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V9320630', 1001, 127, '12/12/93', null, '12/15/93',
'open',         'n',    3,      60000,  0.20, 'hardware');

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V9420099', 1001, 127, '01/17/94', null, '06/01/94',
'open',         'n',    100, 3399.15,   0.15, 'software');


INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V93C0990', 1006, 72, '08/09/93', '09/02/93', null,
'shipped',      'y',    40,     399960.50,      0.10, 'hardware');
INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V9333005', 1002, 11, '02/03/93', '03/03/93', null,
'shipped',      'y',    2,      600.50,         0, 'software');

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V9346200', 1003, 11, '12/31/93', null, '01/24/94',
'waiting',      'n',    3,      0,      1,    'software');

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V9456220', 1007, 127, '01/04/94', null, '01/30/94',
'open',         'y',    1,      3999.99,        0, 'hardware');

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V94S6400', 1011, 141, '01/06/94', null, '02/15/94',
'waiting',      'y',    20,     1980.72,        0.40, 'software');

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V93H0500', 1008, 61, '12/12/93', null, '12/15/93',
'open',         'n',    3,      16000,          0.20, 'hardware');

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V93I4700', 1013, 121, '10/27/93', null, '12/15/93',
'open',         'n',    5,      2693,           0, 'hardware');

INSERT INTO sales
(po_number, cust_no, sales_rep, order_date, ship_date, date_needed,
order_status, paid, qty_ordered, total_value, discount, item_type) VALUES
('V93N5822', 1015, 134, '12/18/93', '01/14/94', null,
'shipped',      'n',    2,      1500.00,        0, 'software');

commit;
exit;

